Subject: Re: SCTP and IP_TOS

From: Vlad Yasevich <[email-masked]>
Date: Mon, 12 Aug 2013 16:21:54 -0400

On 08/12/2013 01:00 PM, Ben Greear wrote:
> Hello!
>
> I notice that I read 0x2 as IP_TOS getsockopt on an SCTP socket configured
> for streaming mode.
>
> Looks to me like the reason is that SCTP uses a socket type of
> SCTP_SOCKET_TCP
> and the ipv4/ip_sockglue.c code is only masking out ECN for SOCK_STREAM
> types.
>
> Is this per design, or should the ip_sockglue.c mask out ECN for
> SCTP_SOCKET_TCP
> types as well?
>
> Thanks,
> Ben
>

 From the ip_glue perspective, you would see either SOCK_STREAM or
SOCK_SEQPACKET.

So you are trying to set tos bits on a SEQPACKET socket, ip_sockglue()
wouldn't try preserver current ECN bits as it does for STREAM sockets.

-vlad